#!/usr/bin/perl
###############
#PerlTkMaker
#GNU GPL v2
#View version in config.pl
use Tk;
use utf8;
do "config.pl";

##############
sub CreateWindow;
sub SetValues;
sub SaveProject;
sub LoadProject;
sub CreateProgramm;
sub StartProgramm;
sub CreateButton;
sub EditElement;
sub CreateFrame;
sub CreateLabel;
sub CreateText;
sub EditStarts;
sub EditLibs;
##############
#######
my @main_lines; my $mlcount=0;
my @lines; my $count=0;
my %prog;
my $PROJECT_NAME; my $saved=0; my $created=0;
#######
my @windows; my $wcount=0; 
my @buttons; my $bcount=0;
my @frames; my $fcount=0;
my @labels; my $lcount=0;
my @texts; my $tcount=0;
#######

#interface
my $leftW = MainWindow->new(-title=>'Инструменты - PerlTkMaker');
my $rightW = MainWindow->new(-title=>'Параметры - PerlTkMaker');
$leftW->geometry('200x600');
$rightW->geometry('200x600');
#Scheeme of right menu...
$rightW->Label(-text => 'Элементы')->pack;
$elements=$rightW->Listbox(-selectmode=>'single')->pack;
$rightW->Label(-text => 'Параметры')->pack;
my $frameText=$rightW->Frame()->pack;                                    # We will make frame to every line. It will make line Happy :D
$frameText->Label(-text => 'Текст:')->pack(-side=>'left');
my $ele_text=$frameText->Entry()->pack(-side=>'left');
my $frameX=$rightW->Frame()->pack;
$frameX->Label(-text => 'РазмерХ:')->pack(-side=>'left');
my $sizeX=$frameX->Entry()->pack(-side=>'left');
my $frameY=$rightW->Frame()->pack;
$frameY->Label(-text => 'РазмерY:')->pack(-side=>'left');
my $sizeY=$frameY->Entry()->pack(-side=>'left');
my $frameSide=$rightW->Frame()->pack;
$frameSide->Button(-text=>'Верх', -command=>sub { $ele_side="top"; })->pack(-side=>'top');
$frameSide->Button(-text=>'Низ', -command=>sub { $ele_side="bottom"; })->pack(-side=>'bottom');
$frameSide->Button(-text=>'Лево', -command=>sub { $ele_side="left"; })->pack(-side=>'left');
$frameSide->Button(-text=>'Право', -command=>sub { $ele_side="right"; })->pack(-side=>'right');
$framePropButtons=$rightW->Frame()->pack;
$framePropButtons->Button(-text=>'Применить', -command=>sub { SetValues; })->pack(-side=>'top');

#scheeme of left menu...
my $menu_frame=$leftW->Frame(-relief=>'groove', -borderwidth=>'3')->pack;
my $menu_file=$menu_frame->Menubutton(-text=>'Файл')->pack(-side=>'left');
$menu_file->command(-label=>'Сохранить проект',-command=>sub { SaveProject; });
$menu_file->command(-label=>'Загрузить проект',-command=>sub { LoadProject; });
$menu_file->command(-label=>'Создать программу',-command=>sub { CreateProgramm; });
$menu_file->separator();
$menu_file->command(-label=>'Запустить программу',-command=>sub { StartProgramm; });
$menu_file->separator();
$menu_file->command(-label=>'Выход',-command=>sub { exit(0); });
my $menu_edit=$menu_frame->Menubutton(-text=>'Правка')->pack(-side=>'left');
$menu_edit->command(-label=>'Элемент',-command=>sub { EditElement; });
$menu_edit->command(-label=>'Стартовые',-command=>sub { EditStarts; });
$menu_edit->command(-label=>'Библиотеки',-command=>sub { EditLibs; });
$menu_edit->separator();
$menu_edit->command(-label=>'Параметры',-command=>sub { SetValues; });
my $menu_info=$menu_frame->Menubutton(-text=>'Информация')->pack(-side=>'left');

$leftW->Label(-text => 'Инструменты')->pack;
my $frameInstruments=$leftW->Frame()->pack;
$frameInstruments->Button(-text=>'W', -command=>sub {CreateWindow;})->pack(-side=>'left');
$frameInstruments->Button(-text=>'B', -command=>sub {CreateButton;})->pack(-side=>'left');
$frameInstruments->Button(-text=>'F', -command=>sub {CreateFrame;})->pack(-side=>'left');
$frameInstruments->Button(-text=>'L', -command=>sub {CreateLabel;})->pack(-side=>'left');
$frameInstruments->Button(-text=>'T', -command=>sub {CreateText;})->pack(-side=>'left');
#end of interface

#functions
#-----------------
$lines[$count]="\%libs=\"use utf8;use Tk;\"";
$prog{"libs"}=\$lines[$count];
$count++;
$main_lines[$mlcount]="\%libs";
$mlcount++;
#----------------
sub CreateWindow {
	#project
	$lines[$count]="\%window$wcount=\"\$window$wcount=MainWindow->new(-title=>\'\%twindow$wcount\'); \$window$wcount->geometry('\%gwindow$wcount');\"";
	$prog{"window$wcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%twindow$wcount=\"Window $wcount\"";
	$prog{"twindow$wcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%gwindow$wcount=\"300x300\"";
	$prog{"gwindow$wcount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%window$wcount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "window$wcount");
	#Visual
	$windows[$wcount]=MainWindow->new(-title=>"Window $wcount");
	$windows[$wcount]->geometry("300x300");
	$wcount++;	
}
sub SetValues {
	my @some=$elements->curselection();
	if( $elements->get( $some[0] )=~/window/ ) {
		my $element_name=$elements->get( $some[0] );
		#project
		${$prog{"t$element_name"}}="\%t$element_name=\"".$ele_text->get()."\"";
		${$prog{"g$element_name"}}="\%g$element_name=\"".$sizeX->get()."x".$sizeY->get()."\"";
		#Visual
		$elements->get( $some[0] )=~/\d{1,}/;
		$windows[$&]->configure(-title=>"".$ele_text->get()."");
		$windows[$&]->geometry("".$sizeX->get()."x".$sizeY->get()."");
	}
	if( $elements->get( $some[0] )=~/button/ ) {
		my $element_name=$elements->get( $some[0] );
		#project
		${$prog{"t$element_name"}}="\%t$element_name=\"".$ele_text->get()."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$ele_side."\"";
		#Visual
		$elements->get( $some[0] )=~/\d{1,}/;
		#print $&;
		$buttons[$&]->configure(-text=>"".$ele_text->get()."");
		$buttons[$&]->pack(-side=>"".$ele_side."");
	}
	if( $elements->get( $some[0] )=~/frame/ ) {
		my $element_name=$elements->get( $some[0] );
		#project
		${$prog{"s$element_name"}}="\%s$element_name=\"".$ele_side."\"";
		#Visual
		$elements->get( $some[0] )=~/\d{1,}/;
		$frames[$&]->pack(-side=>"".$ele_side."");
	}
	if( $elements->get( $some[0] )=~/label/ ) {
		my $element_name=$elements->get( $some[0] );
		#project
		${$prog{"t$element_name"}}="\%t$element_name=\"".$ele_text->get()."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$ele_side."\"";
		#Visual
		$elements->get( $some[0] )=~/\d{1,}/;
		$labels[$&]->configure(-text=>"".$ele_text->get()."");
		$labels[$&]->pack(-side=>"".$ele_side."");
	}
	if( $elements->get( $some[0] )=~/text/ ) {
		my $element_name=$elements->get( $some[0] );
		#project
		${$prog{"w$element_name"}}="\%w$element_name=\"".$sizeX->get()."\"";
		${$prog{"h$element_name"}}="\%h$element_name=\"".$sizeY->get()."\"";
		${$prog{"s$element_name"}}="\%s$element_name=\"".$ele_side."\"";
		#Visual
		$elements->get( $some[0] )=~/\d{1,}/;
		$texts[$&]->configure(-width=>"".$sizeX->get()."",-height=>"".$sizeY->get()."");
		$texts[$&]->pack(-side=>"".$ele_side."");
	}
}
sub SaveProject {
	my $save_dialog=MainWindow->new(-title=>"Сохранить проект");
	$save_dialog->Label(-text=>"Введите имя проекта, после сохранения он появится в текущей папке")->pack;
	$project_name=$save_dialog->Entry()->pack;
	$save_dialog->Button(-text=>"Сохранить", -command=>sub { 
		open my $save_file, "> ".$project_name->get().".ptm" or die "Ошибка создания проекта: $!";
		for(my $i=0; $i < $mlcount; $i++) {
			print $save_file "".$main_lines[$i]."\n";
		}
		if($prog{"starts"}) {print $save_file "\%starts\n";}
		print $save_file "\%end\n";
		##
		print $save_file "VALUES\n";
		##
		for(my $i=0; $i < $count; $i++) {
			print $save_file "".$lines[$i]."\n";
		}
		print $save_file $prog{"starts"};
		print $save_file "%end=\"MainLoop;\"";
		close $save_file;
		$PROJECT_NAME=$project_name->get();
		$save_dialog->destroy();
	})->pack;
	$saved=1;
}
sub CreateProgramm {
	if(!$saved) {
		SaveProject;
	} else {
		`perl ptm2pl.pl $PROJECT_NAME.ptm $PROJECT_NAME.pl`;
		my $created_dialog=MainWindow->new(-title=>"Программа создана");
		$created_dialog->Label(-text=>"Программа $PROJECT_NAME.pl создана!")->pack;
		$created_dialog->Button(-text=>"OK", -command=>sub{ $created_dialog->destroy(); })->pack;
	}
	$created=1;
}
sub StartProgramm {
	if(!$created) {
		CreateProgramm;
	} else {
		`perl $PROJECT_NAME.pl`;
	}
}
sub LoadProject {
	$load_dialog=MainWindow->new(-title=>"Загрузить проект");
	$load_dialog->Label(-text=>"Введите имя проекта:")->pack;
	my $load_name=$load_dialog->Entry()->pack;
	$load_dialog->Button(-text=>"OK", -command=>sub{
		open $load_file, "< ".$load_name->get().".ptm" or die "Ошибка открытия проекта: $!";
		$PROJECT_NAME=$load_name->get();
		my @ptm_lines=<$load_file>;
		close $load_file or die "Ошибка закрытия проекта: $!";
		my $separator;
		my $number_of_lines=scalar @ptm_lines;
		for($separator=0; $separator < $number_of_lines; $separator++) {
			if($ptm_lines[$separator] eq "VALUES\n") { last; }
		}
		#Elements
		#print "sep: $separator\nnum: $number_of_lines\n";
		for(my $i=0; $i < $separator; $i++) {
			if( $ptm_lines[$i]=~/libs/ || $ptm_lines[$i]=~/end/ ||$ptm_lines[$i]=~/lastcom/  ) { next; }
			####
			if( $ptm_lines[$i]=~/window/ ) { $wcount++; }
			####
			$ptm_lines[$i]=~/\%/;
			$find=$';
			chomp $find;
			$elements->insert('end', "$find");
		}
		#Project
		for(my $i=0; $i < $separator; $i++) {
			$main_lines[$i]=$ptm_lines[$i];
		}
		$mlcount=$separator;
		for(my $i=$separator+1 , $j=0; $i<$number_of_lines; $i++ , $j++) {
			$lines[$j]=$ptm_lines[$i];
		}
		$count=$number_of_lines-$separator-1;
		#Visual
		`perl ptm2pl.pl $PROJECT_NAME.ptm $PROJECT_NAME.pl`;
		open $pl_file, "< $PROJECT_NAME.pl" or die "Ошибка загрузки проекта, возможно проект повреждён.";
		my @pl_lines=<$pl_file>;
		close $pl_file;
		open $pl_file, "> temp.pl";
		for(my $i=0; $i < $separator; $i++) {
			if( $ptm_lines[$i]=~/libs/ || $ptm_lines[$i]=~/end/ ||$ptm_lines[$i]=~/lastcom/  ) { next; }
			if( $pl_lines[$i]=~/\$window\d/ ) {
				$&=~/\d{1,}/;
				my $num=$&;
				$pl_lines[$i]=~/\$window\d{1,}/;
				$pl_lines[$i]="$`\$windows[$num]$'";
			}
			if( $pl_lines[$i]=~/\$window\d{1,}/ ) {
				$&=~/\d/;
				my $num=$&;
				$pl_lines[$i]=~/\$window\d/;
				$pl_lines[$i]="$`\$windows[$num]$'";
			}
			print $pl_file $pl_lines[$i];
		}
		close $pl_file;
		do "temp.pl";
		$load_dialog->destroy();
	})->pack;
}
sub CreateFrame {
	my @some=$elements->curselection();
	#project
	$lines[$count]="\%frame$fcount=\"\$frame$fcount=\$".$elements->get( $some[0] )."->Frame()->pack(-side=>\'%sframe$fcount\');\"";
	$prog{"frame$fcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%sframe$fcount=\"top\"";
	$prog{"sframe$fcount"}=\$lines[$count];
	$count++;
	#-----------
	$main_lines[$mlcount]="\%frame$fcount";
	$mlcount++;
	#Elements
	$elements->insert('end', "frame$fcount");
	#Visual
	if($elements->get( $some[0] )=~/window/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$frames[$fcount]=$windows[$&]->Frame()->pack;
	}
	if($elements->get( $some[0] )=~/frame/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$frames[$fcount]=$frames[$&]->Frame()->pack;
	}
	$fcount++;
}
sub CreateLabel {
	my @some=$elements->curselection();
	#project
	$lines[$count]="\%label$lcount=\"\$label$lcount=\$".$elements->get( $some[0] )."->Label(-text=>\'%tlabel$lcount\')->pack(-side=>\'%slabel$lcount\');\"";
	$prog{"label$lcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%tlabel$lcount=\"Label $lcount\"";
	$prog{"tlabel$lcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%slabel$lcount=\"top\"";
	$prog{"slabel$lcount"}=\$lines[$count];
	$count++;
	#------------
	$main_lines[$mlcount]="\%label$lcount";
	$mlcount++;
	#Elements
	$elements->insert('end', "label$lcount");
	#Visual
	if($elements->get( $some[0] )=~/window/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$labels[$lcount]=$windows[$&]->Label(-text=>"Label $lcount")->pack;
	}
	if($elements->get( $some[0] )=~/frame/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$labels[$lcount]=$frames[$&]->Label(-text=>"Label $lcount")->pack;
	}
	$lcount++;
}
sub CreateText {
	my @some=$elements->curselection();
	#project
	$lines[$count]="\%text$tcount=\"\$text$tcount=\$".$elements->get( $some[0] )."->Text(-width=>\'%wtext$tcount\',-height=>\'%htext$tcount\')->pack(-side=>\'%stext$tcount\');\"";
	$prog{"text$tcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%wtext$tcount=\"10\"";
	$prog{"wtext$tcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%htext$tcount=\"10\"";
	$prog{"htext$tcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%stext$tcount=\"top\"";
	$prog{"Htext$tcount"}=\$lines[$count];
	$count++;
	#---------------
	$main_lines[$mlcount]="\%text$tcount";
	$mlcount++;
	#Elements
	$elements->insert('end', "text$tcount");
	#Visual
	if($elements->get( $some[0] )=~/window/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$texts[$tcount]=$windows[$&]->Text(-width=>'10',-height=>'10')->pack;
	}
	if($elements->get( $some[0] )=~/frame/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$texts[$tcount]=$frames[$&]->Text(-width=>'10',-height=>'10')->pack;
	}
	$tcount++;
}
sub CreateButton {
	my @some=$elements->curselection();
	#project
	$lines[$count]="\%button$bcount=\"\$button$bcount=\$".$elements->get( $some[0] )."->Button(-text=>\'%tbutton$bcount\',-command=>sub{%cbutton$bcount})->pack(-side=>\'%sbutton$bcount\');\"";
	$prog{"button$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%tbutton$bcount=\"Button $bcount\"";
	$prog{"tbutton$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%cbutton$bcount=\"\"";
	$prog{"cbutton$bcount"}=\$lines[$count];
	$count++;
	$lines[$count]="\%sbutton$bcount=\"top\"";
	$prog{"sbutton$bcount"}=\$lines[$count];
	$count++;
	#-------------
	$main_lines[$mlcount]="\%button$bcount";
	$mlcount++;
	#Elemets
	$elements->insert('end', "button$bcount");
	#Visual
	if($elements->get( $some[0] )=~/window/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$buttons[$bcount]=$windows[$&]->Button(-text=>"Button $bcount")->pack;
	}
	if($elements->get( $some[0] )=~/frame/) {
		$elements->get( $some[0] )=~/\d{1,}/;
		$buttons[$bcount]=$frames[$&]->Button(-text=>"Button $bcount")->pack;
	}
	$bcount++;	
}
sub EditElement {
	my @some=$elements->curselection();
	open my $temp, "> temp.pl" or die "$!";
	my $element_name=$elements->get( $some[0] );
	$src=${$prog{"c$element_name"}};
	$src=~/\=\"/;
	$'=~/\"/;
	print $temp "$`";
	close $temp  or die "$!";
	`$default_editor temp.pl`;
	my $script="";
	open my $temp, "< temp.pl" or die "$!";
	my @code=<$temp>;
	print @code;
	$code_size=scalar @code;
	for(my $i; $i < $code_size; $i++) {
		chomp $code[$i];
		$script="$script".$code[$i]."";
	}
	close $temp  or die "$!";
	${$prog{"c".$elements->get( $some[0] ).""}}="\%c".$elements->get( $some[0] )."=\"$script\"";
	
}
sub EditStarts {
	open $temp, "> temp.pl";
	$src="%starts=\"\"";
	$src=~/\=\"/;
	$'=~/\"/;
	print $temp "$`";
	close $temp;
	`$default_editor temp.pl`;
	my $script="";
	open $temp, "temp.pl";
	@code=<$temp>;
	$code_size=scalar @code;
	for(my $i; $i < $code_size; $i++) {
		chomp $code[$i];
		$script="$script".$code[$i]."";
	}
	close $temp;
	$prog{"starts"}="\%starts=\"$script\"\n";
}
sub EditLibs {
	open $temp, "> temp.pl";
	$src=${$prog{"libs"}};
	$src=~/\=\"/;
	$'=~/\"/;
	print $temp "$`";
	close $temp;
	`$default_editor temp.pl`;
	my $script="";
	open $temp, "temp.pl";
	@code=<$temp>;
	$code_size=scalar @code;
	for(my $i; $i < $code_size; $i++) {
		chomp $code[$i];
		$script="$script".$code[$i]."";
	}
	close $temp;
	${$prog{"libs"}}="\%libs=\"$script\"";
}
#end of functions;

MainLoop;